diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
index 3f18e2a5e..8edf01461 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
@@ -119,8 +119,8 @@ public class HudIngame extends Gui
         }
 
         for (final HudComponent component : HudComponents.INSTANCE.getComponents()) {
-            if (component.isVisible(this.mc)) {
-                component.render(this.mc, this, width - sp * 2, height - sp * 2, partialTicks);
+            if (component.isVisible()) {
+                component.render(this, width - sp * 2, height - sp * 2, partialTicks);
             }
         }
 
@@ -145,41 +145,28 @@ public class HudIngame extends Gui
         }
 
         //Text Overlays
-        if (mc.gameSettings.immersiveMode.drawOverlays())
-        {
+        if (mc.gameSettings.immersiveMode.drawOverlays()) {
             drawRecordPlayingOverlay(width, height - sp, partialTicks);
 
-            int tsp = 2 + sp;
-            int line = 0;
-            int lineHeight = 10;
-
             boolean clock = false;
             boolean compass = false;
             boolean rotaryCalendar = false;
 
-            if (mc.thePlayer.getGamemode() == Gamemode.creative)
-            {
+            if (mc.thePlayer.getGamemode() == Gamemode.creative) {
                 clock = true;
                 compass = true;
                 rotaryCalendar = true;
-            }
-            else
-            {
-                for (int iinv = 0; iinv < mc.thePlayer.inventory.getContainerSize(); iinv++)
-                {
+            } else {
+                for (int iinv = 0; iinv < mc.thePlayer.inventory.getContainerSize(); iinv++) {
                     ItemStack item = mc.thePlayer.inventory.getItem(iinv);
-                    if (item != null)
-                    {
-                        if (item.itemID == Items.TOOL_CLOCK.id)
-                        {
+                    if (item != null) {
+                        if (item.itemID == Items.TOOL_CLOCK.id) {
                             clock = true;
                         }
-                        if (item.itemID == Items.TOOL_COMPASS.id)
-                        {
+                        if (item.itemID == Items.TOOL_COMPASS.id) {
                             compass = true;
                         }
-                        if (item.itemID == Items.TOOL_CALENDAR.id)
-                        {
+                        if (item.itemID == Items.TOOL_CALENDAR.id) {
                             rotaryCalendar = true;
                         }
                     }
@@ -189,8 +176,7 @@ public class HudIngame extends Gui
             // Show Player List
             if (!mc.gameSettings.showDebugScreen.value) drawPlayerList(width, height, sp);
 
-            if (mc.gameSettings.showDebugScreen.value)
-            {
+            if (mc.gameSettings.showDebugScreen.value) {
                 glPushMatrix();
                 glEnable(GL_BLEND);
                 glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
@@ -220,49 +206,49 @@ public class HudIngame extends Gui
                 drawDebugScreenLineRight(GL11.glGetString(GL11.GL_VERSION));
                 drawDebugScreenLineRight("Resolution: " + mc.gameWindow.getWidthPixels() + "x" + mc.gameWindow.getHeightPixels());
                 drawDebugScreenLineRight("Render Resolution: " + mc.renderer.getRenderWidth() + "x" + mc.renderer.getRenderHeight());
-                
+
                 drawDebugScreenLine("Better than Adventure! " + Minecraft.VERSION);
                 drawDebugScreenLine(mc.debug);
-                if(mc.terrainRenderer instanceof TerrainRendererMultiDraw) {
-                	TerrainRendererMultiDraw terrainRenderer = (TerrainRendererMultiDraw) mc.terrainRenderer;
-                	
-                	int regionCount = terrainRenderer.regionBuffer.size();
+                if (mc.terrainRenderer instanceof TerrainRendererMultiDraw) {
+                    TerrainRendererMultiDraw terrainRenderer = (TerrainRendererMultiDraw) mc.terrainRenderer;
+
+                    int regionCount = terrainRenderer.regionBuffer.size();
 
                     int playerX = MathHelper.floor(mc.thePlayer.x);
                     int playerZ = MathHelper.floor(mc.thePlayer.z);
 
-                	
-                	List<RenderRegion> allRegions = terrainRenderer.regionBuffer.getAllRegions();
+
+                    List<RenderRegion> allRegions = terrainRenderer.regionBuffer.getAllRegions();
                     int totalEntries = 0;
                     int visibleEntries = 0;
-                	for(int i=0; i < allRegions.size(); i++) {
+                    for (int i = 0; i < allRegions.size(); i++) {
                         RenderRegion region = allRegions.get(i);
-                        for(int j=0; j < region.renderLists.length; j++) {
-                        	RenderList renderList = region.renderLists[j];
-                        	if(renderList == null) {
-                        		continue;
-                        	}
-                        	totalEntries += renderList.size();
-                        	visibleEntries += renderList.visibleEntryCount();
+                        for (int j = 0; j < region.renderLists.length; j++) {
+                            RenderList renderList = region.renderLists[j];
+                            if (renderList == null) {
+                                continue;
+                            }
+                            totalEntries += renderList.size();
+                            visibleEntries += renderList.visibleEntryCount();
                         }
-                	}
-                	
-                	drawDebugScreenLine("R: " + regionCount + " D: " + terrainRenderer.getTotalDrawCalls() + " T: " + visibleEntries + "/" + totalEntries + " VBO: " + terrainRenderer.vertexBuffer.entryCount());
-                	
-                	RenderRegion currentRegion = terrainRenderer.getRenderRegionAtBlockPos(playerX, playerZ);
+                    }
+
+                    drawDebugScreenLine("R: " + regionCount + " D: " + terrainRenderer.getTotalDrawCalls() + " T: " + visibleEntries + "/" + totalEntries + " VBO: " + terrainRenderer.vertexBuffer.entryCount());
+
+                    RenderRegion currentRegion = terrainRenderer.getRenderRegionAtBlockPos(playerX, playerZ);
                     totalEntries = 0;
                     visibleEntries = 0;
-                    for(int j=0; j < currentRegion.renderLists.length; j++) {
-                    	RenderList renderList = currentRegion.renderLists[j];
-                    	if(renderList == null) {
-                    		continue;
-                    	}
-                    	totalEntries += renderList.size();
-                    	visibleEntries += renderList.visibleEntryCount();
+                    for (int j = 0; j < currentRegion.renderLists.length; j++) {
+                        RenderList renderList = currentRegion.renderLists[j];
+                        if (renderList == null) {
+                            continue;
+                        }
+                        totalEntries += renderList.size();
+                        visibleEntries += renderList.visibleEntryCount();
                     }
-                	drawDebugScreenLine("CR: " + currentRegion + " E: " + visibleEntries + "/" + totalEntries);
+                    drawDebugScreenLine("CR: " + currentRegion + " E: " + visibleEntries + "/" + totalEntries);
 
-                }else {
+                } else {
                     drawDebugScreenLine(mc.getRendererDebugInfo());
                 }
                 drawDebugScreenLine(mc.getEntityDebugInfoString());
@@ -272,28 +258,24 @@ public class HudIngame extends Gui
                 debugOffset += space;
                 debugOffsetRight += space;
 
-                if (compass)
-                {
+                if (compass) {
                     drawDebugScreenLine("X: " + mc.thePlayer.x);
                     drawDebugScreenLine("Y: " + mc.thePlayer.y);
                     drawDebugScreenLine("Z: " + mc.thePlayer.z);
-                    
+
                     int chunkX = MathHelper.floor(mc.thePlayer.x) >> 4;
-                	int chunkZ = MathHelper.floor(mc.thePlayer.z) >> 4;
-                    
-            		drawDebugScreenLine("Chunk: " + chunkX + ", " + chunkZ);
-            		
+                    int chunkZ = MathHelper.floor(mc.thePlayer.z) >> 4;
+
+                    drawDebugScreenLine("Chunk: " + chunkX + ", " + chunkZ);
+
                     int yaw = DynamicTexture.pmod(java.lang.Math.round(mc.thePlayer.yRot), 360);
                     int pitch = java.lang.Math.round(mc.thePlayer.xRot);
                     drawDebugScreenLine("Facing: " + yaw + "°, " + pitch + "° (" + I18n.getInstance().translateKey(getFacingDirection(mc.thePlayer).getTranslationKey()) + ")");
-                }
-                else
-                {
+                } else {
                     drawDebugScreenLine("Hold a compass for more information");
                 }
 
-                if (clock)
-                {
+                if (clock) {
                     if (!compass) debugOffset += space;
 
                     int playerX = MathHelper.floor(mc.thePlayer.x);
@@ -309,48 +291,42 @@ public class HudIngame extends Gui
 
                 debugOffset += space;
 
-                if (clock)
-                {
-                    drawDebugScreenLine("Time: " + getTimeString() + " (Day " + (mc.currentWorld.getWorldTime() / Global.DAY_LENGTH_TICKS) + ")");
-                }
-                else
-                {
+                if (clock) {
+                    drawDebugScreenLine("Time: " + getTimeString(mc) + " (Day " + (mc.currentWorld.getWorldTime() / Global.DAY_LENGTH_TICKS) + ")");
+                } else {
                     drawDebugScreenLine("Hold a clock for more information");
                 }
 
                 debugOffset += space;
 
-                if (rotaryCalendar)
-                {
+                if (rotaryCalendar) {
                     Season season = mc.currentWorld.getSeasonManager().getCurrentSeason();
                     String seasonString = season != null ? season.getTranslatedName() : "None";
                     Weather weather = mc.currentWorld.getCurrentWeather();
                     String weatherString = weather != null ? stringtranslate.translateKey(weather.getNameLanguageKey()) : "None";
-                    
+
                     int blockX = MathHelper.floor(mc.thePlayer.x);
-					int blockY = MathHelper.floor(mc.thePlayer.y);
-					int blockZ = MathHelper.floor(mc.thePlayer.z);
-                    
+                    int blockY = MathHelper.floor(mc.thePlayer.y);
+                    int blockZ = MathHelper.floor(mc.thePlayer.z);
+
                     drawDebugScreenLine("Season: " + seasonString);
                     drawDebugScreenLine("Weather: " + weatherString + " (" + (mc.currentWorld.weatherManager.getWeatherDuration() / 20) + "s I: " + percentRound(mc.currentWorld.weatherManager.getWeatherIntensity()) + "% P: " + percentRound(mc.currentWorld.weatherManager.getWeatherPower()) + "%)");
                     drawDebugScreenLine("Biome: " + Registries.BIOMES.getKey(mc.currentWorld.getBlockBiome(blockX, blockY, blockZ)));
-                    
+
                     float temperature = (float) floor100(mc.currentWorld.getBlockTemperature(blockX, blockZ));
                     float humidity = (float) floor100(mc.currentWorld.getBlockHumidity(blockX, blockZ));
-                    
+
                     drawDebugScreenLine("Temperature: " + temperature + " Humidity: " + humidity);
-                    
+
                     WindProvider windProvider = mc.currentWorld.worldType.getWindManager();
-                    if(windProvider != null) {
-                    	float direction = (float) floor100(windProvider.getWindDirection(mc.currentWorld, 0.0f, 500.0f, 0.0f));
-                    	float intensity = (float) floor100(windProvider.getWindIntensity(mc.currentWorld, 0.0f, 500.0f, 0.0f));
+                    if (windProvider != null) {
+                        float direction = (float) floor100(windProvider.getWindDirection(mc.currentWorld, 0.0f, 500.0f, 0.0f));
+                        float intensity = (float) floor100(windProvider.getWindIntensity(mc.currentWorld, 0.0f, 500.0f, 0.0f));
 
                         int yaw = DynamicTexture.pmod(java.lang.Math.round((direction * 360.0f) + 270.0f), 360);
-                    	drawDebugScreenLine("Wind: " + yaw + "°, " + java.lang.Math.round(intensity * 100.0f) + "%");
+                        drawDebugScreenLine("Wind: " + yaw + "°, " + java.lang.Math.round(intensity * 100.0f) + "%");
                     }
-                }
-                else
-                {
+                } else {
                     drawDebugScreenLine("Hold a rotary calendar for more information");
                 }
 
@@ -363,23 +339,18 @@ public class HudIngame extends Gui
                 drawDebugScreenLine("CTRL + F3: Show Frametimes");
                 drawDebugScreenLine("F3 + Q: Show Keyboard Shortcuts");
 
-                if (mc.objectMouseOver != null && mc.objectMouseOver.entity == null)
-                {
+                if (mc.objectMouseOver != null && mc.objectMouseOver.entity == null) {
                     debugOffset += space;
 
                     Block<?> block = Blocks.blocksList[mc.currentWorld.getBlockId(mc.objectMouseOver.x, mc.objectMouseOver.y, mc.objectMouseOver.z)];
-                    if (block.id() > 0 && block.id() < Blocks.blocksList.length)
-                    {
+                    if (block.id() > 0 && block.id() < Blocks.blocksList.length) {
                         drawDebugScreenLineRight("Looking at:");
 
                         String name;
                         int meta = mc.currentWorld.getBlockMetadata(mc.objectMouseOver.x, mc.objectMouseOver.y, mc.objectMouseOver.z);
-                        try
-                        {
+                        try {
                             name = block.asItem().getTranslatedName(new ItemStack(block, 1, meta));
-                        }
-                        catch (Exception e)
-                        {
+                        } catch (Exception e) {
                             name = "<ERROR>";
                         }
 
@@ -389,19 +360,17 @@ public class HudIngame extends Gui
                         drawDebugScreenLineRight(block.getLanguageKey(meta));
                         drawDebugScreenLineRight(id);
 
-                        if (compass)
-                        {
+                        if (compass) {
                             drawDebugScreenLineRight("[" + mc.objectMouseOver.x + ", " + mc.objectMouseOver.y + ", " + mc.objectMouseOver.z + "]");
                         }
 
                         drawDebugScreenLineRight("Harvest: " + mc.thePlayer.canHarvestBlock(block));
 
-                        if (clock)
-                        {
+                        if (clock) {
                             int lightX = mc.objectMouseOver.x;
                             int lightY = mc.objectMouseOver.y;
                             int lightZ = mc.objectMouseOver.z;
-                            
+
                             Side side = mc.objectMouseOver.side;
                             lightX += side.getOffsetX();
                             lightY += side.getOffsetY();
@@ -413,10 +382,8 @@ public class HudIngame extends Gui
                         drawDebugScreenLineRight("Signal: " + mc.currentWorld.getSignal(mc.objectMouseOver.x, mc.objectMouseOver.y, mc.objectMouseOver.z, mc.objectMouseOver.side));
                         drawDebugScreenLineRight("Direct signal: " + mc.currentWorld.getDirectSignal(mc.objectMouseOver.x, mc.objectMouseOver.y, mc.objectMouseOver.z, mc.objectMouseOver.side));
 
-                        for (Tag<Block<?>> tag : BlockTags.TAG_LIST)
-                        {
-                            if (tag.appliesTo(block))
-                            {
+                        for (Tag<Block<?>> tag : BlockTags.TAG_LIST) {
+                            if (tag.appliesTo(block)) {
                                 drawDebugScreenLineRight(tag.getName());
                             }
                         }
@@ -424,177 +391,6 @@ public class HudIngame extends Gui
                 }
                 glPopMatrix();
             }
-            if (!mc.gameSettings.showDebugScreen.value)
-            {
-                if (mc.gameSettings.versionInOverlay.value) {
-                    int color;
-                    if (mc.gameSettings.overlayMode.value == 2)
-                    {
-                        color = 0xffff60;
-                    } else {
-                        color = 0xFFFFFF;
-                    }
-                    drawStringShadow(fontRenderer, "Better than Adventure! ", tsp, tsp + lineHeight * line, color);
-                    drawStringShadow(fontRenderer, Global.VERSION, fontRenderer.getLastEndingX(), tsp + lineHeight * line++, 0xffffff);
-                }
-                if (mc.gameSettings.fpsInOverlay.value)
-                {
-                    drawStringShadow(fontRenderer, mc.debugFPS, tsp, tsp + lineHeight * line++, 0xffffff);
-                }
-                if (compass)
-                {
-                    if (mc.gameSettings.overlayShowCoords.value)
-                    {
-                        if (mc.gameSettings.overlayMode.value == 0)
-                        {
-                            drawStringShadow(fontRenderer, "x: " + floor10(mc.thePlayer.x) + " y: " + floor10(mc.thePlayer.y) + " z: " + floor10(mc.thePlayer.z), tsp, tsp + lineHeight * line++, 0xffffff);
-                        }
-                        if (mc.gameSettings.overlayMode.value == 1)
-                        {
-                            drawStringShadow(fontRenderer, "x: " + floor10(mc.thePlayer.x), tsp, tsp + lineHeight * line++, 0xffffff);
-                            drawStringShadow(fontRenderer, "y: " + floor10(mc.thePlayer.y), tsp, tsp + lineHeight * line++, 0xffffff);
-                            drawStringShadow(fontRenderer, "z: " + floor10(mc.thePlayer.z), tsp, tsp + lineHeight * line++, 0xffffff);
-                        }
-                        if (mc.gameSettings.overlayMode.value == 2)
-                        {
-                            drawStringShadow(fontRenderer, "x: " + floor10(mc.thePlayer.x), tsp, tsp + lineHeight * line++, 0xff8080);
-                            drawStringShadow(fontRenderer, "y: " + floor10(mc.thePlayer.y), tsp, tsp + lineHeight * line++, 0x80ff80);
-                            drawStringShadow(fontRenderer, "z: " + floor10(mc.thePlayer.z), tsp, tsp + lineHeight * line++, 0x8080ff);
-                        }
-                    }
-                    if (mc.gameSettings.overlayShowDirection.value)
-                    {
-                        drawStringShadow(fontRenderer, I18n.getInstance().translateKey(getFacingDirection(mc.thePlayer).getTranslationKey()), tsp, tsp + lineHeight * line++, 0xffffff);
-                    }
-                }
-                if (clock)
-                {
-                    if (mc.gameSettings.overlayShowTime.value)
-                    {
-                        if (mc.gameSettings.overlayMode.value == 0)
-                        {
-                            this.drawStringShadow(fontRenderer, String.format("%s %s %d", getTimeString(), I18n.getInstance().translateKey("unit.day"),mc.currentWorld.getWorldTime() / Global.DAY_LENGTH_TICKS), tsp, tsp + lineHeight * line++, mc.gameSettings.overlayMode.value == 2 ? 0xffff80 : 0xffffff);
-                        }
-                        if (mc.gameSettings.overlayMode.value > 0)
-                        {
-                            this.drawStringShadow(fontRenderer, getTimeString(), tsp, tsp + lineHeight * line++, mc.gameSettings.overlayMode.value == 2 ? 0xffff80 : 0xffffff);
-                            this.drawStringShadow(fontRenderer, String.format("%s %d", I18n.getInstance().translateKey("unit.day"),mc.currentWorld.getWorldTime() / Global.DAY_LENGTH_TICKS), tsp, tsp + lineHeight * line++, mc.gameSettings.overlayMode.value == 2 ? 0xffff80 : 0xffffff);
-                        }
-                    }
-                }
-                if (rotaryCalendar)
-                {
-                    if (mc.gameSettings.overlayShowSeason.value)
-                    {
-                        Season season = mc.currentWorld.getSeasonManager().getCurrentSeason();
-                        if (season != null)
-                        {
-                            this.drawStringShadow(fontRenderer, season.getTranslatedName(), tsp, tsp + lineHeight * line++, mc.gameSettings.overlayMode.value == 2 ? 0x80ffff : 0xffffff);
-                        }
-                    }
-                    if (mc.gameSettings.overlayShowWeather.value)
-                    {
-                        Weather weather = mc.currentWorld.getCurrentWeather();
-                        if (weather != null && weather != mc.currentWorld.worldType.getDefaultWeather())
-                        {
-                            this.drawStringShadow(fontRenderer, stringtranslate.translateKey(weather.getNameLanguageKey()), tsp, tsp + lineHeight * line++, mc.gameSettings.overlayMode.value == 2 ? 0xff80ff : 0xffffff);
-                        }
-                    }
-					if(mc.gameSettings.overlayShowBiome.value)
-					{
-						int blockX = MathHelper.floor(mc.thePlayer.x);
-						int blockY = MathHelper.floor(mc.thePlayer.y);
-						int blockZ = MathHelper.floor(mc.thePlayer.z);
-						String key = mc.currentWorld.getBlockBiome(blockX, blockY, blockZ).translationKey;
-						drawStringShadow(fontRenderer, stringtranslate.translateKey(key), tsp, tsp + lineHeight * line++, 0xffffff);
-					}
-                }
-            }
-        }
-
-        if (mc.gameSettings.immersiveMode.drawOverlays() && mc.gameSettings.armorDurabilityOverlay.value)
-        {
-            for (int i = mc.thePlayer.getNumArmorSlots() - 1; i >= 0; i--)
-            {
-                ItemStack stack = mc.thePlayer.getItemInArmorSlot(HumanArmorShape.values()[i]);
-
-                if (stack != null)
-                {
-                    int x = 2 + sp;
-                    int y = height - sp - 64 + i * 16;
-//                    ItemModelDispatcher.getInstance().getDispatch(stack).renderItemIntoGui(Tessellator.instance, font, mc.textureManager, stack, x, y, 1.0f);
-                    ItemModelDispatcher.getInstance().getDispatch(stack).renderGui(Tessellator.instance, null, stack, x, y, 1f, 1.0f, partialTicks);
-
-                    if (stack.isItemStackDamageable())
-                    {
-                        float durability = (stack.getMaxDamage() - stack.getMetadata()) / (float) stack.getMaxDamage();
-
-                        int l = (int) (durability * 255);
-                        final int i1 = 255 - l << 16 | l << 8;
-
-                        glDisable(GL_BLEND);
-                        glDisable(GL_LIGHTING);
-                        drawStringShadow(this.fontRenderer, String.valueOf((stack.getMaxDamage() - stack.getMetadata()) + 1), x + 20, y + 4, i1);
-                    }
-                }
-            }
-            glDisable(GL_BLEND);
-            glDisable(GL_LIGHTING);
-        }
-
-        if (mc.gameSettings.immersiveMode.drawOverlays() && mc.gameSettings.heldItemCountOverlay.value)
-        {
-            ItemStack heldItemStack = mc.thePlayer.inventory.getCurrentItem();
-            if (heldItemStack != null)
-            {
-                int x = width / 2 + 96;
-                int y = height - sp - 19;
-
-
-                boolean renderItem;
-
-                if (heldItemStack.isItemStackDamageable())
-                {
-                    renderItem = true;
-                    float durability = (heldItemStack.getMaxDamage() - heldItemStack.getMetadata()) / (float) heldItemStack.getMaxDamage();
-                    
-                    final int color = Color.HSBtoRGB(durability/3F, 1f, 1f);
-                    int remainingDurability = (heldItemStack.getMaxDamage() - heldItemStack.getMetadata()) + 1;
-                    drawStringShadow(this.fontRenderer, "" + remainingDurability, x + 18, y + 4, color);
-                }
-                else
-                {
-                    int itemCount = 0;
-                    int stackCount = 0;
-                    for (int i = 0; i < mc.thePlayer.inventory.getContainerSize(); i++)
-                    {
-                        ItemStack itemStack = mc.thePlayer.inventory.getItem(i);
-                        if (itemStack != null && itemStack.itemID == heldItemStack.itemID && itemStack.getMetadata() == heldItemStack.getMetadata())
-                        {
-                            itemCount += itemStack.stackSize;
-                            stackCount++;
-                        }
-                    }
-                    renderItem = stackCount >= 1;
-
-                    if (renderItem)
-                    {
-                        drawStringShadow(this.fontRenderer, "" + itemCount, x + 18, y + 4, 0xffffff);
-                    }
-                }
-
-                if (renderItem)
-                {
-                    GL11.glEnable(GL11.GL_DEPTH_TEST);
-                    GL11.glDisable(3042 /* GL_BLEND */);
-                    GL11.glEnable(32826 /* GL_RESCALE_NORMAL_EXT */);
-                    Lighting.enableInventoryLight();
-//                    ItemModelDispatcher.getInstance().getDispatch(heldItemStack).renderItemIntoGui(Tessellator.instance, font, mc.textureManager, heldItemStack, x, y, 1.0f);
-                    ItemModelDispatcher.getInstance().getDispatch(heldItemStack).renderGui(Tessellator.instance, null, heldItemStack, x, y, 1f, 1f, partialTicks);
-                    Lighting.disable();
-                }
-            }
-
         }
 
         if (mc.gameSettings.immersiveMode.drawChat())
@@ -858,9 +654,9 @@ public class HudIngame extends Gui
                 final byte xPad = 2;
                 final int h = MathHelper.ceil( this.fontRenderer.heightOfConstrainedChars(message, MAX_CHAT_WIDTH));
                 y -= (h + 2);
-                drawRect(xPad, y - sp - 1, xPad + MAX_CHAT_WIDTH, y + h - sp + 1, alpha / 2 << 24);
+                drawRect(xPad + sp, y - sp - 1, xPad + MAX_CHAT_WIDTH, y + h - sp + 1, alpha / 2 << 24);
                 GL11.glEnable(GL_BLEND);
-                this.fontRenderer.renderWidthConstrained(Tessellator.instance, message, xPad, y, MAX_CHAT_WIDTH).setShadow().setColor(0xFFFFFF + (alpha << 24)).call();
+                this.fontRenderer.renderWidthConstrained(Tessellator.instance, message, xPad + sp, y - sp, MAX_CHAT_WIDTH).setShadow().setColor(0xFFFFFF + (alpha << 24)).call();
             }
         }
 
@@ -869,7 +665,7 @@ public class HudIngame extends Gui
         GL11.glDisable(3042 /* GL_BLEND */);
     }
 
-    public String getTimeString()
+    public static String getTimeString(Minecraft mc)
     {
         long worldTime = mc.currentWorld.getWorldTime();
         int dayLength = Global.DAY_LENGTH_TICKS;
@@ -1004,13 +800,6 @@ public class HudIngame extends Gui
         colorString = true;
     }
 
-    public void addChatMessageTranslate(String s)
-    {
-        I18n i18n = I18n.getInstance();
-        String result = i18n.translateKey(s);
-        addChatMessage(result);
-    }
-
     public static Direction getFacingDirection(Player player)
     {
         return directions[(MathHelper.floor((double) ((player.yRot * 4F) / 360F) + 0.5D) + 2) & 3];
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponent.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponent.java
index d4f529d98..6646a1f0d 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponent.java
@@ -9,6 +9,8 @@ import net.minecraft.client.gui.hud.component.layout.Layout;
 import net.minecraft.client.gui.hud.component.layout.LayoutSnap;
 
 public abstract class HudComponent {
+    protected static final Minecraft mc = Minecraft.getMinecraft();
+
     private final String key;
     private final int xSize;
     private final int ySize;
@@ -22,9 +24,9 @@ public abstract class HudComponent {
         this.layout = layout;
     }
 
-    public abstract boolean isVisible(Minecraft mc);
+    public abstract boolean isVisible();
 
-    public boolean isEnabled(Minecraft mc) {
+    public boolean isEnabled() {
         return true;
     }
 
@@ -32,31 +34,31 @@ public abstract class HudComponent {
         return key;
     }
 
-    public int getXSize(Minecraft mc) {
-        if (!(mc.currentScreen instanceof ScreenHudDesigner) && !isVisible(mc)) return 0;
+    public int getXSize() {
+        if (!isEnabled() || (!(mc.currentScreen instanceof ScreenHudDesigner) && !isVisible())) return 0;
         return xSize;
     }
 
-    public int getYSize(Minecraft mc) {
-        if (!(mc.currentScreen instanceof ScreenHudDesigner) && !isVisible(mc)) return 0;
+    public int getYSize() {
+        if (!isEnabled() || (!(mc.currentScreen instanceof ScreenHudDesigner) && !isVisible())) return 0;
         return ySize;
     }
 
     public int getAnchorX(ComponentAnchor anchor) {
-        return (int) (anchor.xPosition * this.xSize);
+        return (int) (anchor.xPosition * this.getXSize());
     }
 
     public int getAnchorY(ComponentAnchor anchor) {
-        return (int) (anchor.yPosition * this.ySize);
+        return (int) (anchor.yPosition * this.getYSize());
     }
 
     public Layout getLayout() {
         return layout;
     }
 
-    public abstract void render(Minecraft mc, HudIngame hud, int xSizeScreen, int ySizeScreen, float partialTick);
+    public abstract void render(HudIngame hud, int xSizeScreen, int ySizeScreen, float partialTick);
 
-    public abstract void renderPreview(Minecraft mc, Gui gui, Layout layout, int xSizeScreen, int ySizeScreen);
+    public abstract void renderPreview(Gui gui, Layout layout, int xSizeScreen, int ySizeScreen);
 
     public final String toSettingsString() {
         String layoutString;
